\documentclass[a4paper,12pt]{article}
\usepackage[a4paper]{geometry}
\usepackage{fancyhdr,amsmath,amssymb}
\usepackage{graphicx,subfig,tikz}
\usetikzlibrary{positioning,decorations.pathreplacing,matrix,backgrounds}

\newcommand{\m}[0]{\mathbb}
\newcommand{\C}[0]{\mathcal}

\pagestyle{fancy}
\setlength{\parindent}{0mm}
\setlength{\headheight}{15.0pt}
\lhead{Angus Gruen, u5561004}
\rhead{Analysing Genomic Reads}
\title{Analysing Genomic Reads}
\author{Angus Gruen}

\begin{document}

Let $G$ be a genome and $k$ an integer large enough such that
all $k$-mers in $G$ are unique. Model taking a set of reads $H$
from $G$ as drawing $N$ $k$-mers out of a bucket containing every
k-mer in G with replacment. Then, the probability of observing a
particular set of $k$-mers is the probability of drawing that
set in a particular order multiplied by the number of different
orders possible. (As all $k-mers$ are unique all orders are
equally likely.)
\begin{equation}
	p(H) = M(H)P(\vec{H}).
\end{equation}
This can be solved to be
\begin{equation} \label{ProbH}
	p(H) = \Bigg(N! \prod_{K \in G} \frac{1}{H_K!}\Bigg) \frac{1}{S(G, k)^N},
\end{equation}
where $S(G, k) = |G| - k + 1$ is the number of $k$-mers in G
and $H_K$ is the number of appearances of the $k$-mer $K$ in
the set of reads $H$.

This isn’t exactly what we wanted to solve however. We wish to
find the most likely set of frequency-frequency data. Let $\aleph$
be the set of Frequency-Frequency corresponding to $H$ with $\aleph_i$
denoting the number of $k$-mers that appear $i$ times. We have the
following identities
\begin{gather}
	\label{Consevation of k-mers 1} \sum_{i = 0}^{\infty} \aleph_i = S(G, k)
	\\ \label{Consevation of k-mers 2} \sum_{i = 0}^{\infty} i\aleph_i = \sum_{K \in G} H_K = N.
\end{gather}
Hence we are left to calculating the number of different sets of reads
that produce the same frequency-frequency curve. The idea is that if
$H_{K_1} \neq H_{K_2}$ for some $K_{1, 2} \in G$ then swapping the
frequencies of $K_1$ and $K_2$ will not change the corresponding
frequency-frequency curve. Helpfully, such a swap will also not
change the probability of observing that set of reads.

This can be viewed as the following simpler problem. How many ways
are there to put $S(G, k)$ unique balls into a group of buckets such
that there are $\aleph_0$ balls in the zeroth bucket, $\aleph_1$ in
the first bucket and so on so forth. This is equivalent to asking
the number of ways to arrange $S(G, k)$ coloured balls in a line where
$\aleph_0$ balls are coloured the zeroth colour, $\aleph_1$ are coloured
the first colour so on so forth with balls coloured the same way, identical.
This problem has an easy solution of
\begin{gather} \label{mult}
	T(\aleph) = S(G, k)!\prod_{i = 0}^{\infty} \frac{1}{\aleph_i!}
\end{gather}
Combining Equations \ref{ProbH} and \ref{mult}, the probability of observing
a particular set of frequency-frequency data is
\begin{gather}
	P(\aleph) = \frac{N!S(G, k)!}{S(G, k)^N} \prod_{i = 0}^{\infty} \frac{1}{\aleph_i!} \prod_{K \in G} \frac{1}{H_K!}.
\end{gather}
Note additionally that the number of $K \in G$ with $H_K = i$ is exactly $\aleph_i$. This allows us to rearrange the above equation to be
\begin{gather}
	P(\aleph) = \frac{N!S(G, k)!}{S(G, k)^N} \prod_{i = 0}^{\infty} \big(\frac{1}{i!}\big)^{\aleph_i}\frac{1}{\aleph_i!}.
\end{gather}
Hence the most likely set of frequency frequency data $\aleph_{ML}$ can be found by maximising
\begin{gather}
	\prod_{i = 0}^{\infty} \big(\frac{1}{i!}\big)^{\aleph_i}\frac{1}{\aleph_i!}.
\end{gather}
With the constraints given by equations \ref{Consevation of k-mers 1} and \ref{Consevation of k-mers 2}. Let $\aleph(N, S(G, k))$ be $\aleph_{ML}$ for taking $N$ $k$-mers from a genome $G$.

\vspace{2mm}

The above derevation assumes that there is no errors in the reads however this assumtion can easily be relaxed. Let $\epsilon$ be the likelyhood of a base pair to be mis-read. Then the probability of a $k$-mer containing atleast $1$ error is $1 - (1 - \epsilon)^k \approx k\epsilon$. If $\epsilon$ is small then we can assume that $k$-mers will have at most $1$ error. Hence we model this by assuming that $Nk\epsilon$ of the $k$-mers are drawn from an 'error' bucket containing $3k\times S(G, k)$ k-mers. The estimated frequency-frequency curve can be found by combining $\aleph(N(1 - k\epsilon), S(G, k))$ and $\aleph(Nk\epsilon, 3kS(G, k))$. These multiplicative factors $k\epsilon$ and $3k$ can be refined experimentally.

\vspace{2mm}

A more difficult extension is to relax the assumption that all $k$-mers occur only once.



% \subsection{Modeling Frequency-Frequency Curves} \label{modff}

% Let $n_i$ be the actual number of $k$-mers that appear in the genome with frequency $i$.
% As the genome is finite there is some $m_1 \in \m{N}$ such that $n_i = 0$
% for $i > m_1$. Define $\{K_{i, j}\}$ with $0 < i \leq m_1$ and $0 < j \leq n_i$ to be
% the set of $k$-mers appearing in the genome.

% Model taking a reads file $H$ as drawing $N$ $k$-mers
% out of a bucket with some error rate $\epsilon$. Initially assume
% that $\epsilon = 0$. Define $H_{i, j}$ to be the number of appearances
% of the $k$-mer $K_{i, j}$ in the reads. Then the probability
% of a reads file $H$ can be found using a sampling with replacement model.
% \begin{equation} \label{ProbH}
% 	p(H) = N! \prod_{0 < i \leq m_1, 0 < j \leq n_i} \frac{1}{H_{i, j}!} \left(\frac{i}{N}\right)^{H_{i, j}}.
% \end{equation}
% Let $F$ be a function that takes $k$-mer frequency data and produces 
% frequency-frequency data. Hence $F(H)_i$ is the number 
% of $k$-mers that appear in $H$ with frequency $i$. Additionally,
% let $\C{H}$ refer to a particular set of frequency-frequency data where $\C H_i$ is
% the number of $k$-mers that appear $i$ times, then
% \begin{equation}
% 	p(\C{H}) = \sum_{H \in F^{-1}(\C{H})} p(H).
% \end{equation}
% Using python notation of True $= 1$ and False $= 0$, $F^{-1}$ is
% \begin{equation}
% 	F^{-1}(\C{H}) = \left\{H: \C H_i = \sum_{0 < l < m, 0 < j \leq n_l} \big(H_{l, j} == i\big)\right\}.
% \end{equation}

% The aim of this section is to find $\C{H}_{ML}$, the most likely 
% frequency-frequency curve from taking $N$ $k$-mers from a genome.
% Let $m_2 \in \m N$ be the integer such that $\C{H}_i = 0$ for $i \geq m_2$.
% Then,
% \begin{gather}
% 	\label{Consevation of k-mers 1} \sum_{i = 1}^{m_1} n_i = \sum_{i = 0}^{m_2} \C{H}_i 
% 	\\ \label{Consevation of k-mers 2} \sum_{i = 0}^{m_2} i\C{H}_i = \sum_{i = 1}^{m_1} \sum_{j = 1}^{n_i} H_{i, j} = N.
% \end{gather}

% Consider again equation \ref{ProbH}, using \ref{Consevation of k-mers 2}
% and defining $H_i = \sum_{j = 0}^{n_i} H_{i, j}$ we can write this as
% \begin{equation} \label{SimpProbH}
% 	P(H) = \frac{N!}{N^N} \prod_{i = 1}^{m_1} i^{H_i} \prod_{j = 1}^{n_i} \frac{1}{H_{i, j}!}.
% \end{equation}
% This leads to calculating the multiplicity in a state $H$. The idea is
% that if $H_{i, j} \neq H_{i, k}$ for some $j, k$ then we could swap 
% the frequencies of $K_{i, j}$ and $K_{i, k}$ without changing $P(H)$ or
% $F(H)$. Define $c_{i, x}$ to be number of occurrences of the number 
% $x$ in the set $\{H_{i, j}\}_{0 < j \leq n_i}$. Then $H_i = \sum_{x = 0}^{H_i}x c_{i, x}$
% and $\C H_i = \sum_{x = 1}^{m_1} c_{x, i}$. The multiplicity associated
% to distribution of $H_i$ among $H_{i, j}$ is 
% $(H_i)!\prod_{x = 0}^{H_i} \frac{1}{c_{i, x}!}$. Therefore the 
% multiplicity associated to a state $H$ is
% \begin{equation} \label{multiplicity}
% 	\prod_{i = 1}^{m_1} (H_i)! \prod_{x = 0}^{H_i} \frac{1}{c_{i, x}!}
% \end{equation}

% This leaves us to work out the different $H's$ that can be 
% associated to each $\C H$. This can simply be viewed as a bucket
% problem. We want to find the number of ways to put $\C H_1 \ 1$'s, $\C H_2 \ 2$'s
% so on so forth into $m_1$ buckets so that there is $n_1$ numbers
% in the first bucket, $n_2$ in the second bucket and so on so forth.

% This turns out to be a difficult problem and so make the approximation that $m_1$ is
% equal to $1$. The justification for this is that the number of possible $k$-mers is much
% larger than the size of a genome
% and so most $k$-mers only appear once. This solves the aforementioned problem
% to be $1$ regardless of $\C H$ as there are no choices to make. Additionally, it
% simplifies Equation \ref{SimpProbH} to
% \begin{equation}
% 	P(H) = \frac{N!}{N^N} \prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!}.
% \end{equation}
% Then multiplying equations 7 and 8 gives
% \begin{equation}
% 	p(\C{H}) = \frac{N!(H_1)!}{N^N} \prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!} \prod_{x = 0}^{H_1} \frac{1}{c_{1, x}!} .
% \end{equation}
% As $N$ and $H_1$  are constants, $\C{H}_{ML}$ can be found by maximising
% \[
% 	\prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!} \prod_{x = 0}^{H_1} \frac{1}{c_{1, x}!}
% \]
% As $m_1 = 1$, $c_{1, x} = \C H_x$. Additionally, the number of $H_{1, j}$ equal
% to some $k$ is precisely $\C H_k$. Therefore the above equation can be rewritten as
% \[
% 	\prod_{i = 1}^{N} \left(\frac{1}{i!}\right)^{\C H_i} \frac{1}{(\C H_i)!}.
% \]
% This is a constrained maximisation problem with constraints given in Equations
% \ref{Consevation of k-mers 1} and \ref{Consevation of k-mers 2}. Given an $N$ and
% and $n_1$ maximise over the discrete lattice as follows.

% First, to keep calculations small, take the negative log giving
% \[
% 	G(\C H_1, \cdots, \C H_{N}) = \sum_{i = 1}^{N} \C H_i \log(i!) + \log((\C H_i)!).
% \]
% Next, calculate the discrete partial derivatives in each of the $\C H_i$ directions.
% \[
% 	G(\C H_1, \cdots, \C H_i + 1, \cdots, \C H_{N}) - G(\C H_1, \cdots, \C H_{N}) = \log(i!) + \log(\C H_i + 1).
% \]
% Similarly, taking a partial derivative in the negative direction yields
% \[
% 	G(\C H_1, \cdots, \C H_i - 1, \cdots, \C H_{N}) - G(\C H_1, \cdots, \C H_{N}) = -\log(i!) - \log(\C H_i).
% \]
% Movement around this lattice is restricted by the constraints
% \begin{gather*}
% 	\sum_{i = 0}^{N} \C H_i = n_1
% 	\\ \sum_{i = 0}^{N} i\C H_i = N.
% \end{gather*}
% The first constraint means that for each $\C H_i$ decremented some $\C H_j$ must be incremented and second constraint says that if some set $\C H_{i_1}, \cdots, \C H_{i_m}$ is decremented and another set $\C H_{j_1}, \cdots, \C H_{j_m}$ is incremented then
% \[
% 	\sum_{k = 1}^{m} i_k = \sum_{k = 1}^{m} j_k.
% \]
% From this it should be clear that movement around the lattice
% can be broken down into steps of incrementing a pair $\C H_{i_1}, \C H_{i_2}$
% and decrementing a pair $\C H_{j_1}, \C H_{j_2}$ with 
% $i_1 + i_2 = j_1 + j_2$.\footnote{This algorithm is implemented by the function
% distfinder in Angus/experiment.py.}

% A nice feature of this model is that the error rate can easily
% be incorporated as drawing out of a different bucket with probability $\epsilon$.
% With the assumption that all errors occur with $1$ base changed and there are no
% collisions between errors of different $k$-mers or errors and other $k$-mers, the
% number of $k$-mers in the new bucket will be $63n_1$. Hence if $N$ samples are drawn,
% $\C{H}_{ML}$ can be found by running the above algorithm twice with	parameters $(n_1, (1 - \epsilon)N)$ and $(63n_1, \epsilon N)$ and summing the resultant curves together.
% This produces the curves shown in Figure \ref{theory vs reality}.\footnote{This algorithm is implemented by the function err\_distfinder in Angus/experiment.py. The curves can be found in the Jupyter Notebook: Testing Frequency - Frequency data for different levels of Coverage.}

% So far, the assumption has been that the number of $k$-mers	in the genome and
% the error rate in the reads is known and the aim is to find the frequency-frequency curve. It is possible however, to reverse this and from a frequency-frequency curve estimate the number of $k$-mers	in the genome and the error rate in the reads.

% This reversal requires an error function to	measure the difference between two curves.
% Let $P, Q$ be two frequency-frequency curves with height at $i$ denoted $P_i, Q_i$.
% There are several functions that could be used. Given the similarity that frequency-frequency curves have to probability measures, the Total Variation (TV) or Hellinger distance (H) are functions to try. These are defined as
% \begin{gather*}
% 	TV(P, Q) = \sum_{i} |P_i - Q_i|
% 	\\ H(P, Q) = \sum_{i} (\sqrt{P_i} - \sqrt{Q_i})^2
% \end{gather*}
% Another option, is to try and develop an error function from scratch. As mentioned earlier, there are two important features of frequency-frequency curve. The central peak and, the peak at $1$. Hence consider the error function Peak Difference defined by
% \begin{align*}
% 	\delta(P, Q) & = \left|\log\Big(\frac{P_1}{Q_1}\Big)\right| + 
% 	\frac{1}{2}\left|\log\Big(\frac{P_2}{Q_2}\Big)\right| + 
% 	\left|\log\Big(\frac{P_{max}}{Q_{max}}\Big)\right|
% 	\\ & + \frac{1}{2} \left|\log\Big(\frac{P_{max - 1}}{Q_{max - 1}}\Big)\right|	
% 	+ \frac{1}{2} \left|\log\Big(\frac{P_{max + 1}}{Q_{max + 1}}\Big)\right|
% \end{align*}
% The first two terms relate to the peak at $1$ and how is decays and the other three terms are measuring the central peak.\footnote{If the central peak is at $1$ then only the first $2$ terms are calculated}

% \newpage

% \thispagestyle{plain}
% \newgeometry{top=0.1cm,bottom=0.1cm,left=0.1cm,right=0.1cm}

% \begin{figure}
% 	\hspace{-1.5cm}
% 	\includegraphics[width = 235mm]{figures/Theory_vs_Reality.png}
% 	\caption{Comparing the theoretical and experimental curves.}
% 	\label{theory vs reality}
% \end{figure}

% \restoregeometry

% \newpage

% Treating the distance function as an objective function to be minimised gives an optimisation problem but it is not clear that there will be a unique local minimum. Figure \ref{heatmaps for Convergence} shows that with the Total Variation and Hellinger metrics, the error depends almost entirely on the the genome size until variation in the genome size is tiny. On the other hand the Peak Difference has a much nicer valley shape especially with lower variation.

% This shows that provided the initial point is not too far away from the
% correct genome size, there should be convergence too a local minimum. Hence we need
% to find a method to get a good initial guess. A simple initial estimate for high
% coverage is to take the minimum between the two peaks in the graph and then label
% everything to the left an error and everything to the right an observed $k$-mer. For
% lower coverage it is more difficult so an approximation is to guess the error rate to be a small constant\footnote{In the experiment to create Table \ref{freq results},
% $\epsilon$ was set to $0.01$.} $\epsilon$ and approximate the genome size by
% $1 - \epsilon$ multiplied by the number of observed $k$-mers in the frequency graph.

% As the objective function is not differentiable, a combination of coordinate descent and golden section search was used as a minimisation method. This was trialled on two different coverage levels of one of the artificial genomes. The results of this experiment can be seen in the table below. Note that something not in the table is the speed of convergence, while the speed was basically identical for all the distance functions, it took much longer at the lower coverage level.\footnote{This experiment can be found in the Jupyter notebook Estimating Genome Size and Error Rate.}

\end{document}